diff -BbruN freeswan-1.91.orig/utils/rsakeygen freeswan-1.91/utils/rsakeygen
--- freeswan-1.91.orig/utils/rsakeygen	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/rsakeygen	Wed May 16 13:09:59 2001
@@ -0,0 +1,32 @@
+#!/bin/sh
+# use command line specified directory for rsakeys and publickey files,
+# otherwise use the current directory
+KEYDIR=/usr/local/lib/ipsec
+if [ $# -eq 1 ]
+then 
+  KEYDIR=$1
+fi
+
+# define variables
+KEYFILE=$KEYDIR/rsakeys
+PUBKEY=$KEYDIR/publickey
+IPSEC_SECRETS=/etc/ipsec.secrets
+
+
+# generate rsa keys 
+touch $KEYFILE
+chmod 600 $KEYFILE
+ipsec rsasigkey --random /dev/urandom 1024 > $KEYFILE
+chmod 400 $KEYFILE
+
+# extract public key to write to publickey file
+awk 'NR==3 {print $0}' $KEYFILE | cut -d= -f2 > $PUBKEY
+
+# write the rest part including private key to the ipsec.secrets file
+touch ${IPSEC_SECRETS}
+chmod 600 ${IPSEC_SECRETS}
+echo ": rsa {" > ${IPSEC_SECRETS}
+awk 'NR>3 {print $0}' $KEYFILE >> ${IPSEC_SECRETS}
+echo "	}" >> ${IPSEC_SECRETS}
+chmod 400 ${IPSEC_SECRETS}
+exit 0
diff -BbruN freeswan-1.91.orig/utils/setup freeswan-1.91/utils/setup
--- freeswan-1.91.orig/utils/setup	Wed Jun 13 16:10:07 2001
+++ freeswan-1.91/utils/setup	Mon Jun  4 11:29:01 2001
@@ -1,6 +1,6 @@
 #!/bin/sh
 # IPsec startup and shutdown script
-# Copyright (C) 1998, 1999, 2001  Henry Spencer.
+# Copyright (C) 1998, 1999  Henry Spencer.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: setup,v 1.109 2001/06/13 20:10:07 henry Exp $
+# RCSID $Id: setup,v 1.105 2001/06/01 15:49:14 henry Exp $
 #
 # ipsec         init.d script for starting and stopping
 #               the IPsec security subsystem (KLIPS and Pluto).
@@ -30,10 +30,6 @@
 # description: IPsec provides encrypted and authenticated communications; \
 # KLIPS is the kernel half of it, Pluto is the user-level management daemon.
 
-me='ipsec setup'		# for messages
-
-
-
 if test " $IPSEC_DIR" = " "	# if we were not called by the ipsec command
 then
 	# we must establish a suitable PATH ourselves
@@ -41,6 +37,19 @@
 	export PATH
 fi
 
+me='ipsec setup'		# for messages
+
+# make sure output of (e.g.) ifconfig is in English
+unset LANG LANGUAGE LC_ALL LC_MESSAGES
+
+# verify permissions
+if test " `id -u`" != " 0"
+then
+	echo "permission denied (must be superuser)" |
+		logger -s -p daemon.error -t ipsec_setup
+	exit 1
+fi
+
 # Check that the ipsec command is available.
 found=
 for dir in `echo $PATH | tr ':' ' '`
@@ -60,39 +69,587 @@
 
 # Pick up IPsec configuration (until we have done this, successfully, we
 # do not know where errors should go, hence the explicit "daemon.error"s.)
-# Note the "--export", which exports the variables created.
-eval `ipsec _confread --varprefix IPSEC --export --type config setup`
+eval `ipsec _confread --varprefix IPSEC --type config setup`
 if test " $IPSEC_confreadstatus" != " "
 then
 	echo "$IPSEC_confreadstatus -- \`$1' aborted" |
 		logger -s -p daemon.error -t ipsec_setup
 	exit 1
 fi
-IPSECsyslog=${IPSECsyslog-daemon.error}
-export IPSECsyslog
 
-# misc setup
+# Misc. paths (some of this should perhaps be overrideable from ipsec.conf).
+plutopid=/var/run/pluto.pid
+subsyslock=/var/lock/subsys/ipsec
+info=/var/run/ipsec.info
+sysflags=/proc/sys/net/ipsec
+modules=/proc/modules
+# full rp_filter path is $rpfilter1/interface/$rpfilter2
+rpfilter1=/proc/sys/net/ipv4/conf
+rpfilter2=rp_filter
+ipforward=/proc/sys/net/ipv4/ip_forward
+ipsecversion=/proc/net/ipsec_version
+
+# Misc. configuration (should perhaps be overrideable).
 umask 022
 
 
 
+# some shell functions, to clarify the actual code
+
+# start KLIPS
+startklips() {
+	# load module if necessary
+	if test ! -f $ipsecversion
+	then
+		if test -r $modules		# kernel does have modules
+		then
+			unset MODPATH MODULECONF	# no user overrides!
+			depmod -a >/dev/null 2>&1 && modprobe ipsec
+		fi
+		if test ! -f $ipsecversion
+		then
+			echo "Fatal error, kernel appears to lack KLIPS."
+			exit 1
+		fi
+	fi
+
+	# figure out debugging flags
+	case "$IPSECklipsdebug" in
+	'')	IPSECklipsdebug=none	;;
+	esac
+	echo "KLIPS debug \`$IPSECklipsdebug'" | logonly
+	case "$IPSECklipsdebug" in
+	none)	ipsec klipsdebug --none	;;
+	all)	ipsec klipsdebug --all	;;
+	*)	ipsec klipsdebug --none
+		for d in $IPSECklipsdebug
+		do
+			ipsec klipsdebug --set $d
+		done
+		;;
+	esac
+
+	# figure out misc. kernel config
+	if test -d $sysflags
+	then
+		sysflag "$IPSECfragicmp" "fragicmp" no icmp
+		echo 1 >$sysflags/inbound_policy_check	# no debate
+		sysflag no "no_eroute_pass" no no_eroute_pass	# obsolete parm
+		sysflag no "opportunistic" no opportunistic	# obsolete parm
+		sysflag "$IPSEChidetos" "hidetos" yes tos
+	else
+		echo "Cannot adjust kernel flags, no $sysflags directory!"
+	fi
+
+	# clear tables out in case dregs have been left over
+	ipsec eroute --clear
+	ipsec spi --clear
+
+	# figure out interfaces
+	for i in $IPSECinterfaces
+	do
+		case "$i" in
+		ipsec*=?*)	klipsinterface "$i"	;;
+		%defaultroute)	defaultinterface	;;
+		*)	echo "$me: interface \`$i' not understood, ignored" >&2
+			;;
+		esac
+	done
+
+	# set up default eroute if necessary
+	if test " $IPSECpacketdefault" = " "
+	then
+		case "$IPSECno_eroute_pass" in
+		''|no)	IPSECpacketdefault=drop	;;
+		yes)	IPSECpacketdefault=pass	;;
+		*)	echo "$me: unknown (not yes/no) no_eroute_pass value \`$IPSECno_eroute_pass'" >&2
+			IPSECpacketdefault=drop
+			;;
+		esac
+	fi
+	case "$IPSECpacketdefault" in
+	pass|reject)
+		ipsec eroute --label "packetdefault" --replace --eraf inet \
+			--src 0/0 --dst 0/0 --said "%$IPSECpacketdefault"
+		;;
+	drop)	;;
+	*)	echo "$me: unknown packetdefault value \`$IPSECpacketdefault'" >&2 ;;
+	esac
+}
+
+# set up a system flag based on a variable
+# sysflag value shortname default flagname
+sysflag() {
+	case "$1" in
+	'')	v="$3"	;;
+	*)	v="$1"	;;
+	esac
+	if test ! -f $sysflags/$4
+	then
+		if test " $v" != " $3"
+		then
+			echo "$me: cannot implement $2=$v because" >&2
+			echo "	$sysflags/$4 does not exist" >&2
+			return 1
+		else
+			return 0	# can't set it, but it's default anyway
+		fi
+	fi
+	case "$v" in
+	yes)	echo 1 >$sysflags/$4	;;
+	no)	echo 0 >$sysflags/$4	;;
+	*)	echo "Unknown (not yes/no) $2 value \`$1'"	;;
+	esac
+}
+
+# interfaces=%defaultroute:  put ipsec0 on top of default route's interface
+defaultinterface() {
+	phys=`netstat -nr |
+		awk '$1 == "0.0.0.0" && $3 == "0.0.0.0" { print $NF }'`
+	if test " $phys" = " "
+	then
+		echo "$me: no default route, %defaultroute cannot cope!!!" >&2
+		return			# really should exit, hard to arrange
+	fi
+	if test `echo " $phys" | wc -l` -gt 1
+	then
+		echo "$me: multiple default routes, %defaultroute cannot cope!!!" >&2
+		return			# really should exit, hard to arrange
+	fi
+	next=`netstat -nr |
+		awk '$1 == "0.0.0.0" && $3 == "0.0.0.0" { print $2 }'`
+	klipsinterface "ipsec0=$phys" $next
+}
+
+# set up a Klips interface
+klipsinterface() {
+	# pull apart the interface spec
+	virt=`expr $1 : '\([^=]*\)=.*'`
+	phys=`expr $1 : '[^=]*=\(.*\)'`
+
+	# figure out ifconfig for interface
+	addr=
+	eval `ifconfig $phys |
+		awk '$1 == "inet" && $2 ~ /^addr:/ && $4 ~ /^Mask:/ {
+			gsub(/:/, " ", $0)
+			print "addr=" $3
+			if ($4 == "Bcast")
+				print "type=broadcast"
+			else if ($4 == "P-t-P")
+				print "type=pointopoint"
+			else
+				print "type="
+			print "otheraddr=" $5
+			print "mask=" $7
+		}'`
+	if test " $addr" = " "
+	then
+		echo "$me: unable to determine address of \`$phys'" >&2
+		exit 1
+	fi
+	if test " $type" = " "
+	then
+		echo "$me: \`$phys' is of an unknown type, can't use it" >&2
+		return
+	fi
+	if test " $IPSECoverridemtu" != " "
+	then
+		mtu="mtu $IPSECoverridemtu"
+	else
+		mtu=
+	fi
+	echo "KLIPS $virt on $phys $addr/$mask $type $otheraddr $mtu" | logonly
+
+	# attach the interface and bring it up
+	ipsec tncfg --attach --virtual $virt --physical $phys
+	ifconfig $virt inet $addr $type $otheraddr netmask $mask $mtu
+
+	# if %defaultroute, note the facts
+	if test " $2" != " "
+	then
+		(
+			echo "defaultroutephys=$phys"
+			echo "defaultroutevirt=$virt"
+			echo "defaultrouteaddr=$addr"
+			if test " $2" != " 0.0.0.0"
+			then
+				echo "defaultroutenexthop=$2"
+			fi
+		) >>$info
+	else
+		echo '#dr: no default route' >>$info
+	fi
+
+	# check for advanced-router trouble
+	checkif $virt
+	checkif $phys
+}
+
+# check an interface for problems
+checkif() {
+	rpf=$rpfilter1/$1/$rpfilter2
+	if test -f $rpf
+	then
+		r="`cat $rpf`"
+		if test " $r" != " 0"
+		then
+			echo "WARNING: $1 has route filtering turned on, KLIPS may not work"
+			echo " ($rpf = \`$r', should be 0)"
+		fi
+	fi
+}
+
+# set up manually-keyed connections
+manualconns() {
+	if test " $IPSECmanualstart" != " "
+	then
+		for tu in $IPSECmanualstart
+		do
+			ipsec manual --up $tu
+		done
+	fi
+}
+
+# internal setup for Pluto start
+# sets up vars, so must do its own logging to avoid subprocess
+plutopre() {
+	# searches, if needed
+	if test " $IPSECplutoload" = " %search"
+	then
+		eval `ipsec _confread --varprefix PLUTO --search auto add start background`
+		if test " $PLUTO_confreadstatus" != " "
+		then
+			echo "plutoload: $PLUTO_confreadstatus" | logit
+			echo "unable to determine what conns to add" | logit
+			IPSECplutoload=
+		else
+			IPSECplutoload="$PLUTO_confreadnames"
+		fi
+	fi
+	if test " $IPSECplutostart" = " %search"
+	then
+		eval `ipsec _confread --varprefix PLUTO --search auto start`
+		if test " $PLUTO_confreadstatus" != " "
+		then
+			echo "plutostart: $PLUTO_confreadstatus" | logit
+			echo "unable to determine what conns to start" | logit
+			IPSECplutostart=
+		else
+			IPSECplutostart="$PLUTO_confreadnames"
+		fi
+	fi
+
+	# ensure plutoload > plutoroute > plutostart
+	for s in $IPSECplutostart
+	do
+		found=
+		for lo in $IPSECplutoroute
+		do
+			if test " $lo" = " $s"
+			then
+				found=yes
+			fi
+		done
+		if test ! "$found"
+		then
+			IPSECplutoroute="$IPSECplutoroute $s"
+		fi
+	done
+	for s in $IPSECplutoroute
+	do
+		found=
+		for lo in $IPSECplutoload
+		do
+			if test " $lo" = " $s"
+			then
+				found=yes
+			fi
+		done
+		if test ! "$found"
+		then
+			IPSECplutoload="$IPSECplutoload $s"
+		fi
+	done
+
+	# execute any preliminaries
+	if test " $IPSECprepluto" != " "
+	then
+		$IPSECprepluto 2>&1 | logit
+	fi
+}
+
+# start Pluto daemon
+plutodaemon() {
+	# double-check one little detail
+	if test ! -e /dev/urandom
+	then
+		echo "Cannot start Pluto, system lacks /dev/urandom !!!"
+		exit 1
+	fi
+
+	# figure out options
+	pd=
+	for d in $IPSECplutodebug
+	do
+		pd="$pd --debug-$d"
+	done
+	case "$IPSECuniqueids" in
+	yes)	pd="$pd --uniqueids"	;;
+	no|'')				;;
+	*)	echo "Unknown uniqueids value (not yes/no) \`$IPSECuniqueids'"	;;
+	esac
+
+	# do it
+	if test " $IPSECdumpdir" = " "
+	then
+		ulimit -c 0			# preclude core dumps
+	elif test ! -d "$IPSECdumpdir"
+	then
+		echo "Dumpdir \`$IPSECdumpdir' does not exist, ignored."
+		ulimit -c 0			# preclude core dumps
+	else
+		cd $IPSECdumpdir		# put them where desired
+		ulimit -c unlimited		# and permit them
+	fi
+	echo "Pluto debug \`$IPSECplutodebug'" | logonly
+	ipsec pluto $pd
+}
+
+# Pluto subsystem startup and cleanup, after daemon is running
+plutopost() {
+	# database load
+	if test " $IPSECplutoload" != " "
+	then
+		echo "$IPSECplutoload" | tr ' ' '\n' | column -x -c 100 |
+			tr -s '\t ' '  ' |
+			while read bunch
+			do
+				for tu in $bunch
+				do
+					ipsec auto --add $tu
+				done
+			done
+	fi
+
+	# enable listening
+	ipsec auto --ready
+
+	# execute any cleanup
+	if test " $IPSECpostpluto" != " "
+	then
+		$IPSECpostpluto
+	fi
+
+	# quickly establish routing
+	if test " $IPSECplutoroute" != " "
+	then
+		echo "$IPSECplutoroute" | 
+			tr ' ' '\n' | column -x -c 100 |
+			tr -s '\t ' '  ' |
+			while read bunch
+			do
+				for tu in $bunch
+				do
+					ipsec auto --route $tu
+				done
+			done
+	fi
+}
+
+# Pluto negotiation start (if any)
+plutogo() {
+	# tunnel initiation, which may take a while
+	if test " $IPSECplutostart" != " "
+	then
+		async=
+		p=
+		if test " $IPSECplutowait" = " no"
+		then
+			async="--asynchronous"
+			p=" (asynchronously)"
+		fi
+		for tu in $IPSECplutostart
+		do
+			#echo "Initiating Pluto tunnel \`$tu'$p:"
+			ipsec auto --up $async $tu
+		done
+	fi
+}
+
+# logging control
+logit() {
+	IPSECsyslog=${IPSECsyslog-daemon.error}
+	logger -s -p $IPSECsyslog -t ipsec_setup 2>&1
+}
+logonly() {
+	IPSECsyslog=${IPSECsyslog-daemon.error}
+	logger -p $IPSECsyslog -t ipsec_setup
+}
+
+
+
+# the mainline code
+
+# backward compatibility, defaults.
+if test " $IPSECdump" = " yes" -a " $IPSECdumpdir" = " "
+then
+	IPSECdumpdir=/var/tmp
+fi
+
 # do it
 case "$1" in
-  start|--start|stop|--stop)
-	if test " `id -u`" != " 0"
+  start|--start)
+	# Start things rolling.
+	# First, does it seem to be going already?
+	if test -f $info
 	then
-		echo "permission denied (must be superuser)" |
-			logger -s -p $IPSECsyslog -t ipsec_setup 2>&1
+		echo "FreeS/WAN IPsec apparently already running, start aborted!" | logit
+		exit 1
+	fi
+	# announcement
+	# (Warning, changes to this log message may affect barf.)
+	version="`ipsec --version | awk 'NR == 1 { print $3 }'`"
+	echo "Starting FreeS/WAN IPsec $version..." | logit
+	rm -f $info
+	if test ! -r /dev/random
+	then
+		echo "...unable to start FreeS/WAN IPsec, no /dev/random!" |
+									logit
+		exit 1
+	fi
+	if test ! -r /dev/urandom
+	then
+		echo "...unable to start FreeS/WAN IPsec, no /dev/urandom!" |
+									logit
+		exit 1
+	fi
+	>$info
+	if test ! -r $info
+	then
+		echo "...unable to create $info, aborting start!" | logit
 		exit 1
 	fi
-	tmp=/var/run/ipsec_setup.st
+	startklips 2>&1 | logit
+	if test ! -f $ipsecversion	# hard to test startklips exit status
+	then
+		echo "No KLIPS, cannot continue IPsec startup!"
+		rm -f $info
+		exit 1
+	fi
+	if test -d `dirname $subsyslock`
+	then
+		touch $subsyslock
+	fi
+	manualconns 2>&1 | logit
+	if test " $IPSECpluto" = " no"
+	then
+		pluto=no
+	elif test " $IPSECplutobackgroundload" = " yes"
+	then
+		pluto=back
+	else
+		pluto=fore
+	fi
+	case $pluto in
+	fore|back)
+		plutopre
+		plutodaemon 2>&1 | logit
+		sleep 1				# give it a moment to get going
+		;;
+	esac
+	case $pluto in
+	fore)	plutopost 2>&1 | logit				;;
+	back)	( plutopost ; plutogo ) 2>&1 | logonly &	;;
+	esac
+	fw=`cat $ipforward`
+	if test " $IPSECforwardcontrol" = " yes" -a " $fw" = " 0"
+	then
+		echo "Enabling IP forwarding:" | logonly
+		echo "ipforwardingwas=$fw" >>$info
+		echo 1 >$ipforward
+	fi
+	case $pluto in
+	fore)	plutogo 2>&1 | logit	;;
+	esac
+	echo "...FreeS/WAN IPsec started" | logonly
+
+	echo "Starting background tunnels..." | logit
+	$0 --startbacktunnels
+	;;
+
+  stop|--stop)
+	# Shut things down.
+	if test -r $info
+	then
+		echo "Stopping FreeS/WAN IPsec..." | logit
+		status=0
+		. $info
+	else
+		echo "Stop ordered, but IPsec does not appear to be running!" |
+									logit
+		echo "Doing cleanup anyway..." | logit
+		status=1
+	fi
+	if test " $IPSECforwardcontrol" = " yes" -a " $ipforwardingwas" = " 0"
+	then
+		echo "Disabling IP forwarding:" | logonly
+		echo 0 >$ipforward
+	fi
+	if test ! -f $plutopid
+	then
+		: nothing
+	elif test ! -s $plutopid
+	then
+		echo "Removing empty $plutopid -- pluto still running?" | logit
+		rm -f $plutopid
+	elif kill -0 `cat $plutopid` 2>/dev/null
+	then
+	  (
+		# kill pluto in 30 secs no matter what.
 	(
-		ipsec _realsetup $1
-		echo "$?" >$tmp
-	) 2>&1 | logger -s -p $IPSECsyslog -t ipsec_setup 2>&1
-	st=`cat $tmp`
-	rm -f $tmp
-	exit $st
+			sleep 30
+			echo "30 second timeout expired. Killing Pluto." | logit
+			kill -9 $plutopid &> /dev/null
+		) &> /dev/null &
+		killpid=$!
+		ipsec whack --shutdown | awk '$1 != "002"' | logit
+		sleep 1			# general paranoia
+		# kill the killpid if we still need to.
+		if kill -0 $killpid &> /dev/null ; then
+			kill -9 $killpid &> /dev/null
+		fi
+	  ) 2> /dev/null
+		if test -s $plutopid
+		then
+			echo "Pluto did not go away!  Killing it:" | logit
+			kill `cat $plutopid` 2>&1 | logit
+			sleep 5
+		fi
+		rm -f $plutopid		# harmless if already gone
+	else
+		echo "Removing orphaned $plutopid:" | logit
+		rm -f $plutopid
+	fi
+	for i in `ifconfig | awk '/^ipsec/ { print $1 }'`
+	do
+		ifconfig $i down 2>&1 | logit
+		ipsec tncfg --detach --virtual $i 2>&1 | logit
+	done
+	ipsec klipsdebug --none 2>&1 | logit
+	ipsec eroute --clear 2>&1 | logit
+	ipsec spi --clear 2>&1 | logit
+	i=`lsmod 2>&1 | awk '$1 == "ipsec" { print $1 }'`
+	if test " $i" = " ipsec"
+	then
+		rmmod ipsec 2>&1 | logit
+	fi
+	if test -d `dirname $subsyslock`
+	then
+		rm -f $subsyslock
+	fi
+	rm -f $info
+	echo "...FreeS/WAN IPsec stopped" | logonly
+	exit $status
 	;;
 
   restart|--restart)
@@ -101,8 +658,94 @@
 	;;
 
   status|--status)
-	ipsec _realsetup $1
-	exit
+	if test -f $info
+	then
+		hasinfo=yes
+	fi
+
+	if test -f $subsyslock
+	then
+		haslock=yes
+	fi
+
+	if test -s $plutopid
+	then
+		if ps -p `cat $plutopid` >/dev/null
+		then
+			haspluto=yes
+			plutokind=normal
+		elif ps -C pluto >/dev/null
+		then
+			haspluto=yes
+			plutokind=illicit
+		fi
+	elif ps -C pluto >/dev/null
+	then
+		haspluto=yes
+		plutokind=orphaned
+	fi
+
+	if test -r /proc/net/ipsec_eroute -a \
+		" `wc -l </proc/net/ipsec_eroute`" -gt 0
+	then
+		eroutes=yes
+	fi
+
+	if test -r $ipsecversion
+	then
+		klips=yes
+	elif test -r $modules
+	then
+		klips=maybe
+	else
+		klips=none
+	fi
+               
+	if test "$hasinfo"
+	then
+		echo "started"
+		# might not be a subsystem lock dir, ignore that issue
+		if test "$plutokind" = "normal" -a "$klips" = "yes"
+		then
+			exit 0
+		fi
+		echo "but..."
+		if test ! "$haspluto"
+		then
+			echo "no Pluto running!"
+		else
+			echo "$plutokind Pluto running!"
+		fi
+		case $klips in
+		maybe)  echo "KLIPS module is not loaded!"      ;;
+		none)   echo "no KLIPS in kernel!"              ;;
+		esac
+		if test "$eroutes"
+		then
+		echo "some eroutes exist"
+		fi
+		exit 1
+	else
+		echo "stopped"
+		if test ! "$haslock" -a ! "$haspluto" -a ! "$eroutes"
+		then
+			exit 0
+		fi
+		echo "but..."
+		if test "$haslock"
+		then
+			echo "has subsystem lock!"
+		fi
+		if test "$haspluto"
+		then
+			echo "$plutokind Pluto is running!"
+		fi
+		if test "$eroutes"
+		then
+		echo "some eroutes exist!"
+		fi
+		exit 1
+	fi
 	;;
 
   --version)
@@ -113,6 +756,26 @@
   --help)
 	echo "Usage: $me {--start|--stop|--restart|--status}"
 	exit 0
+	;;
+ 
+  startbacktunnels|--startbacktunnels)
+	(
+	eval `ipsec _confread --varprefix PLUTO --search auto background`
+	if test " $PLUTO_confreadstatus" != " "
+	then
+		echo "$PLUTO_confreadstatus (start search) -- aborting" |
+								logit
+		exit 1
+	fi
+	IPSECplutobackground="$PLUTO_confreadnames"
+
+	(
+	for TUNNEL in $IPSECplutobackground ; 
+	do
+	  ipsec auto --up $TUNNEL 
+	done
+	) &>/dev/null 
+	) &
 	;;
 
   *)
diff -BbruN freeswan-1.91.orig/utils/showhostkey freeswan-1.91/utils/showhostkey
--- freeswan-1.91.orig/utils/showhostkey	Mon Jun 11 22:50:03 2001
+++ freeswan-1.91/utils/showhostkey	Mon Jun  4 11:29:24 2001
@@ -1,6 +1,6 @@
 #! /bin/sh
-# show key for this host, in DNS (or other) format
-# Copyright (C) 2000, 2001  Henry Spencer.
+# show key for this host, in DNS format
+# Copyright (C) 2000  Henry Spencer.
 # 
 # This program is free software; you can redistribute it and/or modify it
 # under the terms of the GNU General Public License as published by the
@@ -12,15 +12,14 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: showhostkey,v 1.9 2001/06/12 02:50:03 henry Exp $
+# RCSID $Id: showhostkey,v 1.8 2001/06/01 15:49:14 henry Exp $
 
 me="ipsec showhostkey"
-usage="Usage: $me [--file secrets] [--left] [--right] [--txt gateway] [--id id]"
+usage="Usage: $me [--file secrets] [--left] [--right] [--txt gateway]"
 
 file=/etc/ipsec.secrets
 fmt="dns"
 gw=
-id=
 for dummy
 do
 	case "$1" in
@@ -28,7 +27,6 @@
 	--left)	fmt="left"		;;
 	--right)	fmt="right"	;;
 	--txt)	fmt="txt" ; gw="$2" ; shift	;;
-	--id)	id="$2" ; shift		;;
 	--version)	echo "$me $IPSEC_VERSION" ; exit 0	;;
 	--help)	echo "$usage" ; exit 0	;;
 	--)	shift ; break		;;
@@ -65,19 +63,10 @@
 		file = "'"$file"'"
 		fmt = "'"$fmt"'"
 		gw = "'"$gw"'"
-		id = "'"$id"'"
 		comment = ""
-		s = "[ \t]+"
-		os = "[ \t]*"
-		x = "[^ \t]+"
-		suffix = ":" s "RSA" s "{$"
-		if (id == "")
-			pat = "^" suffix
-		else
-			pat = "^(" x s ")*" id "(" s x ")*" os suffix
 		status = 0
 	}
-	$0 ~ pat {
+	/^:[ \t]+RSA[ \t]+{$/ {
 		inkey = 1
 		seenkey = 1
 	}
diff -BbruN freeswan-1.91.orig/utils/updown.firewall freeswan-1.91/utils/updown.firewall
--- freeswan-1.91.orig/utils/updown.firewall	Wed Dec 31 19:00:00 1969
+++ freeswan-1.91/utils/updown.firewall	Wed May 16 10:57:20 2001
@@ -0,0 +1,166 @@
+#! /bin/sh
+# sample updown script for ipchains
+# Copyright (C) 2000  D. Hugh Redelmeier, Henry Spencer
+# sample updown script for iptables
+# Copyright (C) 2000  Luc Lanthier
+# 
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 2 of the License, or (at your
+# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
+# 
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+# for more details.
+#
+# RCSID $Id: updown.firewall,v 1.1.2.9 2001/03/27 18:44:16 lanthierl Exp $
+#
+# Modifications: Add ipchains rules specific to Netwinder OfficeServer to
+# let FreeS/WAN work with the firewall. Dacheng Tang
+
+KERNVER=`uname -r | cut -d. -f 1,2`
+
+# check interface version
+case "$PLUTO_VERSION" in
+1.0)    echo "$0: Pluto interface version 1.0 is obsolete." >&2
+        ;;
+1.1)    ;;
+*)      echo "$0: unknown interface version \`$PLUTO_VERSION'" >&2
+        exit 2
+        ;;
+esac
+
+# check parameter(s)
+case "$*" in
+'')     ;;
+*)      echo "$0: parameters unexpected" >&2
+        exit 2
+        ;;
+esac
+
+# utility functions for route manipulation
+# Meddling with this stuff should never be necessary and is most unwise.
+uproute() {
+    route add -net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK \
+      dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP
+      st=$?
+      if test $st -ne 0
+      then
+        # route has already given its own cryptic message
+        echo "$0: \`route $1 $parms' failed" >&2
+      fi
+      return $st
+}
+
+downroute() {
+    route del -net $PLUTO_PEER_CLIENT_NET netmask $PLUTO_PEER_CLIENT_MASK \
+      dev $PLUTO_INTERFACE gw $PLUTO_NEXT_HOP 
+      st=$?
+      if test $st -ne 0
+      then
+        # route has already given its own cryptic message
+        echo "$0: \`route $1 $parms' failed" >&2
+      fi
+      return $st
+
+}
+
+# the big choice
+case "$PLUTO_VERB" in
+prepare-host|prepare-client)
+        # delete possibly-existing route (preliminary to adding a route)
+        oops="`route del -net $PLUTO_PEER_CLIENT_NET \
+                                        netmask $PLUTO_PEER_CLIENT_MASK 2>&1`"
+        status="$?"
+        if test " $oops" = " " -a " $status" != " 0"
+        then
+                oops="silent error in route command, exit status $status"
+        fi
+        case "$oops" in
+        'SIOCDELRT: No such process')
+                # This is what route (currently -- not documented!) gives
+                # for "could not find such a route".
+                status=0
+                ;;
+        esac
+        exit $status
+        ;;
+route-host|route-client)
+        # connection to this host or client being routed
+        uproute
+        ;;
+unroute-host|unroute-client)
+        # connection to this host or client being unrouted
+        downroute
+        ;;
+up-host)
+        # connection to this host coming up
+        ;;
+down-host)
+        # connection to this host going down
+        ;;
+up-client)
+  if [ "$KERNVER" = "2.2" ];
+  then
+	# add an input rule to let KLIPS decapsulated packets pass ipsec0
+	ipchains -A input -i $PLUTO_INTERFACE -j ACCEPT -p all \
+		-d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, coming up
+        ipchains -I forward -j ACCEPT -b \
+                -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+                -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+  elif [ "$KERNVER" = "2.4" ];
+  then
+    # add an input rule to let KLIPS decapsulated packets pass ipsec0
+    iptables -A INPUT -i $PLUTO_INTERFACE -j ACCEPT \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, coming up
+    iptables -I FORWARD -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    iptables -I FORWARD -j ACCEPT \
+        -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+    if ( iptables -t nat -L -n &> /dev/null ) ; then
+      iptables -t nat -I POSTROUTING -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    fi
+  fi
+  ;;
+down-client)
+  if [ "$KERNVER" = "2.2" ];
+  then
+	# delete the input rule for the KLIPS decapsulated packets 
+	ipchains -D input -i $PLUTO_INTERFACE -j ACCEPT -p all \
+		-d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, going down
+        ipchains -D forward -j ACCEPT -b \
+                -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+                -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+  elif [ "$KERNVER" = "2.4" ];
+  then
+    # delete the input rule for the KLIPS decapsulated packets
+    iptables -D INPUT -i $PLUTO_INTERFACE -j ACCEPT \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+        # connection to client subnet, through forwarding firewall, going down
+    iptables -D FORWARD -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    iptables -D FORWARD -j ACCEPT \
+        -s $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK \
+        -d $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK
+    if ( iptables -t nat -L -n &> /dev/null ) ; then
+      iptables -t nat -D POSTROUTING -j ACCEPT \
+        -s $PLUTO_MY_CLIENT_NET/$PLUTO_MY_CLIENT_MASK \
+        -d $PLUTO_PEER_CLIENT_NET/$PLUTO_PEER_CLIENT_MASK
+    fi
+  fi
+  # force a zero error code even the ipchains command(s) failed
+  echo "ok"
+  ;;
+*)      echo "$0: unknown verb \`$PLUTO_VERB' or parameter \`$1'" >&2
+        exit 1
+        ;;
+esac
diff -BbruN freeswan-1.91.orig/version.c freeswan-1.91/version.c
--- freeswan-1.91.orig/version.c	Wed May 30 09:02:20 2001
+++ freeswan-1.91/version.c	Tue Jul  3 04:02:51 2001
@@ -1,2 +1,2 @@
 /* silly pointless RCSID $Id: version.c,v 1.19 2001/05/30 13:02:20 henry Exp $ */
-static const char freeswan_version[] = "1.91";
+static const char freeswan_version[] = "FreeSWAN-1.91-pkix1";
